	list      p=16F84A            
	#include <p16F84A.inc>        

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _RC_OSC

#define	_PCF8583_ADR	0xA2

ControlByte     EQU     0x20
#define    _STOP    ControlByte, 0
#define    _START   ControlByte, 1
#define    _RW      ControlByte, 2
#define    _ACK     ControlByte, 3

#define	_SCL	PORTB,0
#define	_SDA	PORTB,1

#define	Lcd_port	PORTB
#define	_E	Lcd_port,3
#define	_RS	Lcd_port,2

#define	_WRITE_		0
#define	_READ_		1


;***** VARIABLE DEFINITIONS******************************
;
;		  0x0C  0x2D   
;
;************************************************************
_hour		EQU		0x0C
_min		EQU		0x0D
_sec		EQU		0x0E
w_temp        EQU     0x2E       
status_temp   EQU     0x2F       
LSB			equ	0
MSB			equ		7
TRUE		equ		1
FALSE		equ		0

		CBLOCK	0x30
			DelayCount
			Bus_Status
			SlaveAddr
			DataByte
			Bus_Control
			BitCount
			DataByteCopy
			Read_delay
			del_ms
			LCD_Data
			del_767us
			LCD_nibble
			button_down
			but_dwn_delay
			time_count
			_time
			_set_GGRAM
			_FSR
			but_up_delay
			button_rel
			_FSR_T
			timer_on
			tmr_count
		ENDC



;*************************************************************************************
;			    I2C 
;*************************************************************************************

#define	_Bus_Busy		Bus_Status,0
#define	_Abort			Bus_Status,1
#define	_Txmt_Progress	Bus_Status,2
#define	_Rcv_Progress	Bus_Status,3

#define	_Txmt_Success	Bus_Status,4
#define	_Rcv_Success	Bus_Status,5
#define	_Fatal_Error	Bus_Status,6
#define	_ACK_Error		Bus_Status,7

;*************************************************************************************
;			    I2C
;*************************************************************************************
#define	_10BitAddr		Bus_Control,0
#define	_Slave_RW		Bus_Control,1
#define	_Last_Byte_Rcv	Bus_Control,2

#define	_SlaveActive	Bus_Control,6
#define	_TIME_OUT_		Bus_Control,7

;**********************************************************************************************************
;				  
;**********************************************************************************************************

RELEASE_BUS	MACRO
			bsf	STATUS,RP0		;  1 
			bsf	_SDA		;  SDA
			bsf	_SCL		; SCL
			ENDM

;**********************************************************************
		ORG     0x000             
  		goto    main              


		ORG     0x004             
		movwf   w_temp            ;     W
		movf	STATUS,w          ;     STATUS
		movwf	status_temp       
		
		bcf		INTCON, T0IF
		clrf	TMR0
		movlw	.100
		movwf	TMR0
		
		
		;	   0
		btfss	PORTA,0			;  ?
		goto	_0_UP				;     
		btfss	button_down,0	; ,    
		goto	_0_DWN				; ,   
		btfss	button_rel,0	;   
		call	button_0		; ,  
		goto	restor			;    
		
_0_DWN		
		decf	but_dwn_delay	;  
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; ,  
		bsf		button_down,0	; ,    
		movlw	.2				;   
		movwf	but_dwn_delay
		goto	_T_RD
_0_UP		
		btfss	button_down,0 	;    
		goto	_2_BTN_RD		; ,   
		decf	but_up_delay	; ,   
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; ,  
		bcf		button_down,0	; ,  
		bcf		button_rel,0	
		movlw	.2				;   
		movwf	but_up_delay
			
_2_BTN_RD  ;	   2
		btfss	PORTA,2			;  ?
		goto	_2_UP				;     
		btfss	button_down,2	; ,    
		goto	_2_DWN				; ,   
		btfss	button_rel,2	;   
		call	button_2		; ,  
		goto	restor				; ,   
_2_DWN		
		decf	but_dwn_delay	;  
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; ,  
		bsf		button_down,2	; ,    
		movlw	.2				;   
		movwf	but_dwn_delay
		goto	_T_RD
_2_UP		
		btfss	button_down,2	;   ?
		goto	_3_BTN_RD				; ,   
		decf	but_up_delay	; ,  
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; ,  
		bcf		button_down,2	; ,  
		bcf		button_rel,2	
		movlw	.2				;   
		movwf	but_up_delay
		goto	_T_WR				; , 
		;goto	_3_RD

_3_BTN_RD	;   3
		btfss	PORTA,3			;  ?
		goto	_3_UP				;     
		btfss	button_down,3	; ,    
		goto	_3_DWN				; ,   
		btfss	button_rel,3	;   
		call	button_3		; ,  
		goto	restor				; , 
_3_DWN		
		decf	but_dwn_delay	;  
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; , 
		bsf		button_down,3	; ,    
		movlw	.2				;   
		movwf	but_dwn_delay
		goto	_T_RD
_3_UP		
		btfss	button_down,3	;   ?
		goto	_T_RD				; , 
		decf	but_up_delay	; ,  
		btfss	STATUS,Z		;  ?
		goto	_T_RD				; , 
		bcf		button_down,3	; ,  
		bcf		button_rel,3	
		movlw	.2				;   
		movwf	but_up_delay

_T_WR		;   
		movf	FSR,w
		sublw	0x0E
		btfss	STATUS,Z
		goto	$+3
		;    PCF8583
		call	Write_time
		bcf		timer_on,1
		movlw	.2				;   
		movwf	but_up_delay
		;	   PCF 8583
_T_RD		
		movf	FSR,w
		sublw	0x0C
		btfsc	STATUS,Z
		goto	$+5
		movf	FSR,w
		sublw	0x0E
		btfss	STATUS,Z
		goto	restor
		decf	Read_delay
		btfss	STATUS,Z
		goto	restor		
		call	Read_time
		call	show_time
		
		;  
		call	Work
restor	;    	
		movf    status_temp,w     
		movwf	STATUS            
		swapf   w_temp,f
		swapf   w_temp,w          
		retfie                    

main	;    	
		clrf	FSR
		movlw	0x0C
		movwf	FSR
		movlw	0x0F
		movwf	_FSR_T
		movlw	0x05
		movwf	_set_GGRAM
		
		movlw	.2				;   
		movwf	but_dwn_delay
		movlw	.2				;   
		movwf	but_up_delay
		
		movlw	.0
		movwf	PORTA
		bsf		STATUS,RP0
		movlw	0x86
		movwf	OPTION_REG	;      20 
		movlw	0x0F
		movwf	TRISA
		clrf	TRISB
		bcf		STATUS,RP0
		
		call	Init_I2C_Slave
		call	pcf8583_init
		bsf		timer_on,1		;    , 1 - ,     
		movlw	.10
		movwf	Read_delay
		call	lcd_init
		
wait
		
		goto	wait

;*********************************************
;		  
;*********************************************

;*********************************************
;	 0   
;	   
;*********************************************
button_0:
		
		bcf		INTCON,T0IE
		;    
		movf	FSR,w
		sublw	0x1B
		btfss	STATUS,Z
		goto	$+4
		;       ()
		movlw	0x0C
		movwf	FSR
		;movlw	.1
		;movwf	tmr_count
		goto	_0_END
		;        
		movf	FSR,w
		sublw	0x0C
		btfsc	STATUS,Z
		goto	_RD_DATA
		movf	FSR,w
		sublw	0x0E
		btfss	STATUS,Z
		goto	_RD_DATA
		;        
		movlw	0x31
		movwf	tmr_count
		movlw	0x0F
		movwf	FSR
		
_RD_DATA
		;    
		movf	INDF,w
		movwf	_time
		incf	FSR,f
		;   LCD    
		movf	_set_GGRAM,w	; *********
		sublw	0x05
		btfsc	STATUS,Z
		call	metka
		movf	_set_GGRAM,w
		addlw	0x80			;	   GGRAM
		movwf	LCD_Data		;
		call	lcd_byte_com	;*********
		call	show_char
		movlw	.3	
		addwf	_set_GGRAM,f
		movf	_set_GGRAM,w
		sublw	0x0B
		btfss	STATUS,Z
		goto	button_0
		movlw	0x05
		movwf	_set_GGRAM
		incf	tmr_count,f
_0_END		
		bsf		button_rel,0
		bsf		INTCON,T0IE
		return


;**********************************************************
;		 2    
;**********************************************************
button_2:
		
		;   
		movf	FSR,w		
		movwf	_FSR
		movlw	.2
		subwf	FSR,f
		
		;   
		movf	INDF,w
		movwf	_time
		swapf	_time
		movf	_time,w
		andlw	0x03
		sublw	0x02
		btfss	STATUS,Z
		goto	$+2			;   20 
							;   
		goto	_24_TST		;    20   
		;     
		swapf	_time
		movf	_time,w
		andlw	0x0F
		sublw	0x09
		btfss	STATUS,Z
		goto	_1h_INC		;      
		goto	_10h_INC	;   
_1h_INC	;  
		;     
		incf	_time
		movf	_time,w
		movwf	INDF
		movlw	0x85			;	   GGRAM 0x05
		movwf	LCD_Data		;
		call	lcd_byte_com
		call	show_char
		;        
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,2
		return
		
_10h_INC	;  , ,      
		movlw	0xF0
		andwf	_time,f
		swapf	_time
		incf	_time
		swapf	_time
		movf	_time,w
		movwf	INDF
		movlw	0x85			;	   GGRAM 0x05
		movwf	LCD_Data		;
		call	lcd_byte_com
		call	show_char
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,2
		return
		
_24_TST	;   24 
		;     
		;     
		swapf	_time
		movf	_time,w
		andlw	0x0F
		sublw	0x03
		btfss	STATUS,Z
		goto	_1h_INC
		movlw	0xC0
		andwf	_time,f
		movf	_time,w
		movwf	INDF
		movlw	0x85			;	   GGRAM 0x05
		movwf	LCD_Data		;
		call	lcd_byte_com
		call	show_char
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,2
		return
	

;**********************************************************
;		 3    
;**********************************************************
button_3:
		
		;   
		movf	FSR,w		
		movwf	_FSR
		movlw	.1
		subwf	FSR,f
		
		;   
		movf	INDF,w
		movwf	_time
		;     
		swapf	_time
		movf	_time,w
		andlw	0x07
		sublw	0x05
		btfss	STATUS,Z
		goto	$+2
		goto	_5X_TST
		;     
		swapf	_time
		movf	_time,w
		andlw	0x0F
		sublw	0x09
		btfss	STATUS,Z
		goto	_1m_INC
		goto	_10m_INC
_1m_INC	;       
		incf	_time
		movf	_time,w
		movwf	INDF
		movlw	0x88			
		movwf	LCD_Data		
		call	lcd_byte_com	
		call	show_char
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,3
		return
		
_10m_INC
		movlw	0xF0
		andwf	_time,f
		swapf	_time
		incf	_time
		swapf	_time
		movf	_time,w
		movwf	INDF
		movlw	0x88			
		movwf	LCD_Data		
		call	lcd_byte_com	
		call	show_char
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,3
		return
		
_5X_TST
		swapf	_time
		movf	_time,w
		andlw	0x0F
		sublw	0x09
		btfss	STATUS,Z
		goto	_1m_INC
		movlw	0x80
		andwf	_time,f
		movf	_time,w
		movwf	INDF
		movlw	0x88			
		movwf	LCD_Data		
		call	lcd_byte_com	
		call	show_char
		movf	_FSR,w
		movwf	FSR
		bsf		button_rel,3
		return

;*********************************
;	    
;*********************************

metka:
		call	set_begin
		movlw	A't'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A'm'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A'r'
		movwf	LCD_Data
		call	lcd_byte
		movf	tmr_count,w
		movwf	LCD_Data
		call	lcd_byte
		movlw	0x05
		movwf	_set_GGRAM
		return
;*********************************
;	/  
;*********************************
Work:
		
		;    
		btfsc	timer_on,1
		return
		;   
		;     
		movf	FSR,w
		movwf	_FSR
		movf	_FSR_T,w
		movwf	FSR
		;            
		movf	INDF,w
		movwf	_time
		movf	_hour,w
		subwf	_time,w
		btfss	STATUS,Z
		;     	
		goto	$+2		
		;   ,   
		goto	$+4		
		movf	_FSR,w
		movwf	FSR
		return
		;            
		incf	FSR
		movf	INDF,w
		movwf	_time
		movf	_min,w
		subwf	_time,w
		btfss	STATUS,Z
		goto	_NEXT
		;      
		btfss	PORTA,4		
		goto	$+3
		bcf		PORTA,4
		goto	$+2
		bsf		PORTA,4
		;    
		movf	FSR,w
		sublw	0x1A
		btfss	STATUS,Z
		goto	$+6		; ..      
		
		movf	_FSR,w		;         
		movwf	FSR			
		movlw	0x0F		;     
		movwf	_FSR_T
		return
		;      
		;       
		incf	_FSR_T
		incf	_FSR_T
		movf	_FSR,w
		movwf	FSR
		return
		
_NEXT	;        
		movf	_FSR,w
		movwf	FSR
		return
		
;*********************************
;  i2C
;*********************************
Init_I2C_Slave:

        clrf	ControlByte
		bsf		STATUS,RP0
		bsf		_SCL		;  TRIS  SCL  SDA  
		bsf		_SDA		;   
		

		bcf		STATUS,RP0
        movf	PORTB,W
		andlw	b'00000000'		
		movwf	PORTB		;  SDA  SCL  0.       TRIS 

		clrf	TMR0
		movlw	.100
		movwf	TMR0
      	bsf		INTCON,T0IE		;  
		bsf		INTCON,GIE 
		return

;**************************************************************
;		 
;		 
;*************************************************************
pcf8583_init:
		call	TxmtStartBit
		
		movlw	_PCF8583_ADR
		movwf	SlaveAddr
		call	Txmt_Slave_Addr

		movlw	0x00
		movwf	DataByte
		call	SendData

		movlw	0x00
		movwf	DataByte
		call	SendData

		call	TxmtStopBit
		movlw	.100
		movwf	Read_delay
		return

		
;**************************************************************
;		 
;
;*************************************************************
pcf8583_stop:
		call	TxmtStartBit
		
		movlw	_PCF8583_ADR
		movwf	SlaveAddr
		call	Txmt_Slave_Addr

		movlw	0x00
		movwf	DataByte
		call	SendData

		movlw	0x80
		movwf	DataByte
		call	SendData

		call	TxmtStopBit
		movlw	.10 ;.100
		movwf	Read_delay
		return

;**********************************************
;		   pcf8583
;
;*********************************************

Read_time:
		
		call	TxmtStartBit

		movlw	_PCF8583_ADR
		movwf	SlaveAddr

		call	Txmt_Slave_Addr

		movlw	0x02
		movwf	DataByte
		call	SendData

		call	TxmtStartBit

		movlw	_PCF8583_ADR
		movwf	SlaveAddr
		bsf		_Slave_RW

		call	Txmt_Slave_Addr
		bcf		_Slave_RW

		movlw	0x0E
		movwf	FSR
		call	GetData
		movf	DataByte,w
		movwf	INDF	;  
		
		decf	FSR
		call	GetData
		movf	DataByte,w
		movwf	INDF	;  

		decf	FSR
		bsf		_Last_Byte_Rcv
		call	GetData
		movf	DataByte,w
		movwf	INDF	;  
		bcf		_Last_Byte_Rcv
		movlw	0x0E
		movwf	FSR

		call	TxmtStopBit
		movlw	.10
		movwf	Read_delay
		return


;**********************************************
;		   pcf8583
;
;*********************************************

Write_time:
		
		
		call	pcf8583_stop
		call	TxmtStartBit

		movlw	_PCF8583_ADR
		movwf	SlaveAddr
		
		
		call	Txmt_Slave_Addr

		movlw	0x02
		movwf	DataByte
		call	SendData

		movlw	0x0E
		movwf	FSR
		movf	INDF,w
		movwf	DataByte	
		call	SendData
		
		decf	FSR
		movf	INDF,w
		movwf	DataByte	
		call	SendData

		decf	FSR
		movf	INDF,w
		movwf	DataByte	
		call	SendData
		
		movlw	0x0E
		movwf	FSR

		call	TxmtStopBit
		call	pcf8583_init
		return

		
;*********************************************************************************************************
;					   I2C
;
;*********************************************************************************************************

TxmtStartBit:
		bsf		STATUS,RP0		;   1
		bsf		_SDA		;    1
		bsf		_SCL		;    1

        call	Delay5uSec	; 
;
		bcf		_SDA		;          
;
		call	Delay5uSec	; 
;
		bsf		_Bus_Busy	;    

		bcf		STATUS,RP0
		return

;*********************************************************************************************************
;					  
;
;*********************************************************************************************************

TxmtStopBit:
		bsf		STATUS,RP0		
		bcf		_SCL		
		bcf		_SDA		
		bsf		_SCL		
		call	Delay5uSec	
		bsf		_SDA		
;
		bcf		_Bus_Busy	;  
		
		bcf		STATUS,RP0
		return	

;*********************************************************************************************************
;				  
;
;*********************************************************************************************************

Txmt_Slave_Addr:
		
		bcf		_ACK_Error		;    
		goto	SevenBitAddr

SevenBitAddr:
		movf	SlaveAddr,W
		movwf	DataByte		;    DataByte 
		bcf		DataByte,LSB
		btfsc	_Slave_RW		;       
		bsf		DataByte,LSB		;  

EndTxmtAddr:
		call	SendData		;  

;       

_AddrSendTest:
		btfss	_Txmt_Success		;      
		goto	_AddrSendFail
		;clrwdt
		retlw	TRUE

_AddrSendFail:
		;clrwdt
		btfss	_ACK_Error
		retlw	FALSE			;      

;    ,  
;					
		call	TxmtStopBit
		retlw	FALSE			
;
;*********************************************************************************************************
;				  
;
;*********************************************************************************************************
SendData:
		
		goto	TxmtByte
			
;
TxmtByte:
		movf	DataByte,W
        movwf	DataByteCopy	;   DataByte 
		bsf		_Txmt_Progress	;     
		bcf		_Txmt_Success	;    
		movlw	0x08
		movwf	BitCount
		bsf		STATUS,RP0
    

TxmtNextBit:
		
		bcf		_SCL
		rlf     DataByteCopy, F	;   
        bcf		_SDA
		btfsc	STATUS,C
		bsf		_SDA
		call	Delay5uSec	;  
		bsf		_SCL		;    1
		call	Delay5uSec	;  
		decfsz	BitCount, F
		goto	TxmtNextBit
;
;  
;
		bcf		_SCL		;    0
		bsf		_SDA		;    1
		call	Delay5uSec	; 
		bsf		_SCL		;     1   
		call	Delay5uSec		
		bcf		STATUS,RP0		; s 
		btfsc	_SDA		; SDA   1,   
        goto	_TxmtErrorAck
;
		bsf		STATUS,RP0
		bcf		_SCL		;    0

		bcf		_Txmt_Progress	;   
		bsf		_Txmt_Success	;    
		bcf		_ACK_Error	;   

		bcf	STATUS,RP0
		return

_TxmtErrorAck:	;   
		RELEASE_BUS
		bcf		_Txmt_Progress	;   
		bcf		_Txmt_Success	;    
		bsf		_ACK_Error	;   

		bcf	STATUS,RP0
		return
;
;*********************************************************************************************************
;
;				    
;*********************************************************************************************************

GetData:
		
		goto	RcvByte

RcvByte:
		
		bsf		_Rcv_Progress	;   
		bcf		_Rcv_Success	;   

		movlw	0x08
		movwf	BitCount		;   
	

RcvNextBit:		;   
		bsf		STATUS,RP0		
		bcf		_SCL
		bsf		_SDA		
		call	Delay5uSec	
		bsf		_SCL		
		call	Delay5uSec	
	
		bcf		STATUS,RP0		
		bcf		STATUS,C
		btfsc	_SDA
		bsf		STATUS,C	;   1
					
        rlf		DataByte, F	;      
		decfsz	BitCount, F
		goto	RcvNextBit
;
;   ,     
;    NACK 
;
		bsf		STATUS,RP0
		bcf		_SCL
		bcf		_SDA		; ACK -    0
		btfsc	_Last_Byte_Rcv
		bsf		_SDA		; i  NACK -    1
		call	Delay5uSec	
		bsf		_SCL
		call	Delay5uSec	
RcvEnd:
		bcf		_SCL		

		bcf		_Rcv_Progress	;   
		bsf		_Rcv_Success	;   
		bcf		_ACK_Error	; ACK OK
	
		return

;**********************************************
;		 LCD
;
;**********************************************
lcd_init:
		
		call	Delay20ms
		movlw	0x03
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay5ms
		movlw	0x03
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay1ms
		movlw	0x03
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay1ms
		movlw	0x02
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay1ms
		movlw	0x28		;4 ,  , 58 
		movwf	LCD_Data
		call	lcd_byte_com
		movlw	0x08		;  
		movwf	LCD_Data
		call	lcd_byte_com
		call	clear		; 
		movlw	0x06		;  1,   
		movwf	LCD_Data
		call	lcd_byte_com
		;movlw	0x0C		;     (_)
		movlw	0x0E		;  c   ( )
		movwf	LCD_Data
		call	lcd_byte_com
		
		return

;**********************************************
;		   LCD
;
;**********************************************
lcd_nibble_com:
		swapf	LCD_nibble,f
		movf	LCD_nibble,w
		andlw	0xF0
		movwf	Lcd_port
		bsf		_E
		bcf		_E
		return


lcd_byte_com:
		swapf	LCD_Data,f
		movf	LCD_Data,w
		andlw	0x0F
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay5ms
		swapf	LCD_Data,f
		movf	LCD_Data,w
		andlw	0x0F
		movwf	LCD_nibble
		call	lcd_nibble_com
		call	Delay5ms
		movlw	0xF0
		movwf	Lcd_port
		return

;**********************************************
;		   LCD
;
;**********************************************
lcd_nibble:
		
		swapf	LCD_nibble,f
		movf	LCD_nibble,w
		andlw	0xF0
		movwf	Lcd_port
		bsf		_RS
		bsf		_E
		bcf		_E
		return


lcd_byte:
		swapf	LCD_Data,f
		movf	LCD_Data,w
		andlw	0x0F
		movwf	LCD_nibble
		call	lcd_nibble
		call	Delay5ms
		swapf	LCD_Data,f
		movf	LCD_Data,w
		andlw	0x0F
		movwf	LCD_nibble
		call	lcd_nibble
		call	Delay5ms
		movlw	0xF0
		movwf	Lcd_port
		return
		
;************************************************
;		 
;************************************************

clear:
		movlw	0x01
		movwf	LCD_Data
		call	lcd_byte_com
		return

;***************************************************
;		  
;**************************************************
set_begin:
		movlw	0x02
		movwf	LCD_Data
		call	lcd_byte_com
		return
		
;***********************************************
;		
;***********************************************
colon:
		movlw	0x3A
		movwf	LCD_Data
		call	lcd_byte
		return
		
;***********************************************
;		   
;***********************************************
show_time:
		;movlw	0x84			;	   GGRAM 0x04
		;movwf	LCD_Data		;
		;call	lcd_byte_com
		call	set_begin
		movlw	A't'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A'i'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A'm'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A'e'
		movwf	LCD_Data
		call	lcd_byte
		movlw	A' '
		movwf	LCD_Data
		call	lcd_byte
		movlw	0x05
		movwf	_set_GGRAM
		
		movf	_hour,w
		movwf	_time
		call	show_char
		call	colon
		
		movf	_min,w
		movwf	_time
		call	show_char
		return
		
show_char:
		swapf	_time,w
		andlw	0x0F
		addlw	0x30
		movwf	LCD_Data
		call	lcd_byte
		movf	_time,w
		andlw	0x0F
		addlw	0x30
		movwf	LCD_Data
		call	lcd_byte
		return
;*********************************************************************************************************
;			 LCD
;*********************************************************************************************************
Delay5uSec:
		nop
		return
		
Delay50uSec:
		movlw	.15
		movwf	del_ms
		decfsz	del_ms
		goto	$-1
		return	
Delay1ms:
		movlw	.2
		movwf	del_ms
		goto	$+6
Delay5ms:
		movlw	.7
		movwf	del_ms
		goto	$+3
Delay20ms:
		movlw	.34
		movwf	del_ms
		clrf	del_767us
		decfsz	del_767us
		goto	$-1
		decfsz	del_ms
		goto	$-4
		return

		END                    

